*** /usr/helios/u0/jef/src/pbmplus/libtiff/tif_open.c.orig	Thu Nov 15 11:16:30 1990
--- tif_open.c	Thu Nov 15 17:40:47 1990
***************
*** 1,5 ****
  #ifndef lint
! static char sccsid[] = "@(#)tif_open.c	1.17 5/15/90";
  #endif
  
  /*
--- 1,5 ----
  #ifndef lint
! static char rcsid[] = "$Header: /usr/people/sam/tiff/libtiff/RCS/tif_open.c,v 1.19 90/11/15 17:40:30 sam Exp $";
  #endif
  
  /*
***************
*** 55,70 ****
  	}
  }
  
! /*
!  * Open a TIFF file for read/writing.
!  */
! TIFF *
! TIFFOpen(name, mode)
! 	char *name, *mode;
  {
! 	static char module[] = "TIFFOpen";
! 	TIFF *tif;
! 	int m, fd, bigendian;
  
  	switch (mode[0]) {
  	case 'r':
--- 55,65 ----
  	}
  }
  
! static int
! getMode(mode, module)
! 	char *mode, *module;
  {
! 	int m = -1;
  
  	switch (mode[0]) {
  	case 'r':
***************
*** 80,97 ****
  		break;
  	default:
  		TIFFError(module, "\"%s\": Bad mode", mode);
! 		return ((TIFF *)0);
  	}
  	fd = TIFFOpenFile(name, m, 0666);
  	if (fd < 0) {
  		TIFFError(module, "%s: Cannot open", name);
  		return ((TIFF *)0);
  	}
  	tif = (TIFF *)malloc(sizeof (TIFF) + strlen(name) + 1);
  	if (tif == NULL) {
  		TIFFError(module, "%s: Out of memory (TIFF structure)", name);
! 		(void) close(fd);
! 		return ((TIFF *)0);
  	}
  	bzero((char *)tif, sizeof (*tif));
  	tif->tif_name = (char *)tif + sizeof (TIFF);
--- 75,125 ----
  		break;
  	default:
  		TIFFError(module, "\"%s\": Bad mode", mode);
! 		break;
  	}
+ 	return (m);
+ }
+ 
+ /*
+  * Open a TIFF file for read/writing.
+  */
+ TIFF *
+ TIFFOpen(name, mode)
+ 	char *name, *mode;
+ {
+ 	static char module[] = "TIFFOpen";
+ 	int m, fd;
+ 
+ 	m = getMode(mode, module);
+ 	if (m == -1)
+ 		return ((TIFF *)0);
  	fd = TIFFOpenFile(name, m, 0666);
  	if (fd < 0) {
  		TIFFError(module, "%s: Cannot open", name);
  		return ((TIFF *)0);
  	}
+ 	return (TIFFFdOpen(fd, name, mode));
+ }
+ 
+ /*
+  * Open a TIFF file descriptor for read/writing.
+  */
+ TIFF *
+ TIFFFdOpen(fd, name, mode)
+ 	int fd;
+ 	char *name, *mode;
+ {
+ 	static char module[] = "TIFFFdOpen";
+ 	TIFF *tif;
+ 	int m, bigendian;
+ 
+ 	m = getMode(mode, module);
+ 	if (m == -1)
+ 		goto bad2;
  	tif = (TIFF *)malloc(sizeof (TIFF) + strlen(name) + 1);
  	if (tif == NULL) {
  		TIFFError(module, "%s: Out of memory (TIFF structure)", name);
! 		goto bad2;
  	}
  	bzero((char *)tif, sizeof (*tif));
  	tif->tif_name = (char *)tif + sizeof (TIFF);
***************
*** 200,205 ****
--- 228,236 ----
  bad:
  	tif->tif_mode = O_RDONLY;	/* XXX avoid flush */
  	(void) TIFFClose(tif);
+ 	return ((TIFF *)0);
+ bad2:
+ 	(void) close(fd);
  	return ((TIFF *)0);
  }
  
